align		macro n
			org ($ + n - 1) / n * n
			endm

copy16		macro dest
			ld sp,0
			pop af
			pop bc
			pop de
			pop hl
			exx
			ex af,af'
			pop af
			pop bc
			pop de
			pop hl
			ld sp,dest+16
			push hl
			push de
			push bc
			push af
			exx
			ex af,af'
			push hl
			push de
			push bc
			push af
			endm
			
copy16a		macro src,dest
			ld sp,src
			pop af
			pop bc
			pop de
			pop hl
			exx
			ex af,af'
			pop af
			pop bc
			pop de
			pop hl
			ld sp,dest+16
			push hl
			push de
			push bc
			push af
			exx
			ex af,af'
			push hl
			push de
			push bc
			push af
			endm
			
			org 0x7a00
floor
			include "floor.asm"
			
			org 0x7d90
			incbin "attract1.bin"
						
			org 0x9c10

attract
			; copy logo to screen 7
			ld a,0x17
			call safe_page
			ld hl,0x4000
			ld de,0xc000
			ld bc,0x1b00
			ldir
			ld de,64*5
			call wait_for_frame
; set attributes for ground level
			ld hl,0x5ac0
			ld de,0x5ac1
			ld (hl),0x20	; black on green
			ld bc,0x20
			ldir
			ld (hl),0x02	; red on black
			ld c,0x20
			ldir
			ld hl,0x5ac0
			ld de,0xdac0
			ld bc,0x40
			ldir
			ld a,5
			out (254),a

			ld bc,32*5
attract_lp
			halt
			push bc
;			xor a
;			out (254),a
			ld bc,0x7ffd
			ld a,0x1d		; screen 7 shown, page 5 active
			out (c),a
			
bgpos		ld hl,0x0000	; rightshifted bitmap
			inc l
			res 6,l
			ld (bgpos+1),hl
			ld de,0x8010
			add hl,de
			ld de,80

			ld a,0x40
			ld bc,copylen*2
			ld ix,copystart+1
			
bgcopyrow
			ld (ix),l
			ld (ix+1),h
			add ix,bc
			add hl,de
			dec a
			jp nz,bgcopyrow
			
bgpos2		ld hl,0x0010	; rightshifted bitmap
			inc l
			res 6,l
			ld (bgpos2+1),hl
			ld de,0x8010
			add hl,de
			ld de,80

			ld a,0x40
			; ld bc,copylen*2 - unchanged
			ld ix,copystart+copylen+1

bgcopyrow2			
			ld (ix),l
			ld (ix+1),h
			add ix,bc
			add hl,de

			dec a
			jp nz,bgcopyrow2

			call copybg
			
;			ld a,5
;			out (254),a

			halt
;			xor a
;			out (254),a
			ld bc,0x7ffd
			ld a,0x17		; screen 5 shown, page 7 active
			out (c),a
			
			ld b,51
			ld de,copylen
			ld hl,copystart+2			
bgbumprow
			set 5,(hl)
			set 4,(hl)
			add hl,de
			set 5,(hl)
			set 4,(hl)
			add hl,de
			djnz bgbumprow

			ld b,13
bgbumprow2
			set 3,(hl)
			add hl,de
			set 3,(hl)
			add hl,de
			djnz bgbumprow2

attrpos		ld hl,0x0000
			inc l
			res 6,l
			ld (attrpos+1),hl
			ld de,0x7d90
			add hl,de
			
			ld de,80
			ld a,8
			ld bc,copylen*2
			ld ix,attribstart+1			
attrshift
			ld (ix),l
			ld (ix+1),h
			add ix,bc
			add hl,de
			dec a
			jp nz,attrshift

attrpos2	ld hl,0x0010
			inc l
			res 6,l
			ld (attrpos2+1),hl
			ld de,0x7d90
			add hl,de
			
			ld de,80
			ld a,8
			ld bc,copylen*2
			ld ix,attribstart+copylen+1			
attrshift2
			ld (ix),l
			ld (ix+1),h
			add ix,bc
			add hl,de
			dec a
			jp nz,attrshift2

			call copybg

;			ld a,5
;			out (254),a
			pop bc
			dec bc
			ld a,b
			or c
			jp nz,attract_lp

			; clear screen to black on black
			xor a
			out (254),a
			ld hl,0x4000
			ld de,0x4001
			ld (hl),a
			ld bc,0x1aff
			ldir
			ret

copybg
			ld (spback+1),sp
copystart
			copy16 0xc8c0
copylen		equ $ - copystart
			copy16 0xc8d0
			copy16 0xc9c0
			copy16 0xc9d0
			copy16 0xcac0
			copy16 0xcad0
			copy16 0xcbc0
			copy16 0xcbd0
			copy16 0xccc0
			copy16 0xccd0
			copy16 0xcdc0
			copy16 0xcdd0
			copy16 0xcec0
			copy16 0xced0
			copy16 0xcfc0
			copy16 0xcfd0

			copy16 0xc8e0
			copy16 0xc8f0
			copy16 0xc9e0
			copy16 0xc9f0
			copy16 0xcae0
			copy16 0xcaf0
			copy16 0xcbe0
			copy16 0xcbf0
			copy16 0xcce0
			copy16 0xccf0
			copy16 0xcde0
			copy16 0xcdf0
			copy16 0xcee0
			copy16 0xcef0
			copy16 0xcfe0
			copy16 0xcff0
			

			copy16 0xd000
			copy16 0xd010
			copy16 0xd100
			copy16 0xd110
			copy16 0xd200
			copy16 0xd210
			copy16 0xd300
			copy16 0xd310
			copy16 0xd400
			copy16 0xd410
			copy16 0xd500
			copy16 0xd510
			copy16 0xd600
			copy16 0xd610
			copy16 0xd700
			copy16 0xd710

			copy16 0xd020
			copy16 0xd030
			copy16 0xd120
			copy16 0xd130
			copy16 0xd220
			copy16 0xd230
			copy16 0xd320
			copy16 0xd330
			copy16 0xd420
			copy16 0xd430
			copy16 0xd520
			copy16 0xd530
			copy16 0xd620
			copy16 0xd630
			copy16 0xd720
			copy16 0xd730

			copy16 0xd040
			copy16 0xd050
			copy16 0xd140
			copy16 0xd150
			copy16 0xd240
			copy16 0xd250
			copy16 0xd340
			copy16 0xd350
			copy16 0xd440
			copy16 0xd450
			copy16 0xd540
			copy16 0xd550
			copy16 0xd640
			copy16 0xd650
			copy16 0xd740
			copy16 0xd750

			copy16 0xd060
			copy16 0xd070
			copy16 0xd160
			copy16 0xd170
			copy16 0xd260
			copy16 0xd270
			copy16 0xd360
			copy16 0xd370
			copy16 0xd460
			copy16 0xd470
			copy16 0xd560
			copy16 0xd570
			copy16 0xd660
			copy16 0xd670
			copy16 0xd760
			copy16 0xd770

			copy16 0xd080
			copy16 0xd090
			copy16 0xd180
			copy16 0xd190
			copy16 0xd280
			copy16 0xd290
			copy16 0xd380
			copy16 0xd390
			copy16 0xd480
			copy16 0xd490
			copy16 0xd580
			copy16 0xd590
			copy16 0xd680
			copy16 0xd690
			copy16 0xd780
			copy16 0xd790

			copy16 0xd0a0
			copy16 0xd0b0
			copy16 0xd1a0
			copy16 0xd1b0
			copy16 0xd2a0
			copy16 0xd2b0
			copy16 0xd3a0
			copy16 0xd3b0
			copy16 0xd4a0
			copy16 0xd4b0
			copy16 0xd5a0
			copy16 0xd5b0
			copy16 0xd6a0
			copy16 0xd6b0
			copy16 0xd7a0
			copy16 0xd7b0

; attributes
attribstart
			copy16a 0x7d90,0xd9c0
			copy16a 0x7da0,0xd9d0
			copy16a 0x7de0,0xd9e0
			copy16a 0x7df0,0xd9f0

			copy16a 0x7e30,0xda00
			copy16a 0x7e40,0xda10
			copy16a 0x7e80,0xda20
			copy16a 0x7e90,0xda30
			copy16a 0x7ed0,0xda40
			copy16a 0x7ee0,0xda50
			copy16a 0x7f20,0xda60
			copy16a 0x7f30,0xda70
			copy16a 0x7f70,0xda80
			copy16a 0x7f80,0xda90
			copy16a 0x7fc0,0xdaa0
			copy16a 0x7fd0,0xdab0

; do 'PRESS  START' flash, while we're here
startmsg_attr	equ 0xd9b6	; addr of attribute square following 'PRESS  START'
startflashpos
			ld a,0
			inc a
			and 0x0f
			ld (startflashpos+1),a
			; alternate between 0x28 and 0x2d
			cp 0x06
			sbc a,a
			and 0x05
			or 0x28
			ld h,a
			ld l,a
			ld sp,startmsg_attr
			push hl
			push hl
			push hl
			push hl
			push hl
			push hl

spback		ld sp,0


			; display floor
floorpos
			ld hl,floor
			inc l
			res 5,l
			ld (floorpos+1),hl
			ld de,0xd0c0
			call ldi32
			ld de,0xd1c0
			ld bc,0x0020
			add hl,bc
			call ldi32
			ld de,0xd6c0
			ld bc,0x0020
			add hl,bc
			call ldi32
			ld de,0xd7c0
			ld bc,0x0020
			add hl,bc
			call ldi32
			
			ld de,0xd0e0
			ld b,8
lowerfloor
			push bc
			push de
			ld bc,0x0020
			add hl,bc
			call ldi32
			pop de
			inc d
			pop bc
			djnz lowerfloor
			
			ret

ldi32
			rept 32
			ldi
			endm
			ret
			
			org 0xb010
			incbin "attract2.bin"