class DeltaCompressor

	attr_reader :output

	def initialize(first_frame)
		@mirror = []
		for byte in (0..255)
			# switch bit ordering
			newbyte = 0
			(0..7).each do |i|
				if (byte & (1 << i) > 0)
					newbyte |= (1 << (7-i))
				end
			end
			@mirror[byte] = newbyte
		end

		@curr_scr = to_scr(first_frame)
		@output = []
	end
	
	def compress(new_frame)
		flip = [0,4,2,6,1,5,3,7]
		new_scr = to_scr(new_frame)
		i = 0
		while i < 6144
			if (@curr_scr[i] != new_scr[i])
				diff = []
				diff_start = i
				while (@curr_scr[i] != new_scr[i] && i < 6144 && diff.length < 7)
					diff << new_scr[i]
					i += 1
				end
				@output << (flip[diff.length] | ((diff_start/256) << 3)) << (diff_start % 256)
				@output += diff
			else
				i += 1
			end
		end
		@output << 0
		@curr_scr = new_scr
	end

	def to_scr(canvas)
		bmp = canvas.to_blob
		screen = [];
		for third in (0..2)
			for char in (0..7)
				for pix in (0..7)
					yline = bmp.slice(third*0x0800 + pix*0x0100 + char*0x0020, 0x0020)
					yline.each_byte do |byte|
						screen << @mirror[byte]
					end
				end
			end
		end
		return screen
	end
end
