		org 0x8200

		include "interrupt_81.sym"

star_frames		equ 44

		; make second screen white
		ld a,0x17
		call safe_page_81
		ld hl,0xd800
		ld de,0xd801
		ld (hl),0x3f
		ld bc,0x02ff
		ldir
		ld a,0x14
		call safe_page_81

		; do a few frames of animation to get all bytes filled in
		call stars_anim
		call stars_anim
		call stars_anim
		call stars_anim
		; now fill in the correct attributes
		ld hl,0x5800
		ld de,0x5801
		ld (hl),0x46
		ld bc,32
		ldir
		ld (hl),0x43
		ld bc,31
		ldir
		ld hl,0x5800
		ld bc,64
		ldir
		ld hl,0x5880
		ld de,0x5881
		ld (hl),0x47
		ld bc,511
		ldir
		ld hl,0x5800
		ld bc,128
		ldir

		ld de,384 +20
		call wait_for_frame_81

		ld bc,576
stars_mainlp
		halt
		xor a
		out (254),a
		push bc
		call text_printer
		call stars_anim
		pop bc
		dec bc
		ld a,b
		or c
		jp nz,stars_mainlp
		
; fancy text clearer
		ld b,32
textclear1_lp
		halt
		push bc
		call text_printer
		call stars_anim
		call text_clear
		pop bc
		djnz textclear1_lp

		ld hl,0x5085
		ld (text_clear_pos+1),hl
		ld b,32
textclear2_lp
		halt
		push bc
		call text_printer
		call stars_anim
		call text_clear
		pop bc
		djnz textclear2_lp

		ld hl,tp_instructions2
		ld (tp_instr_ptr+1),hl
		ld bc,640-20
stars_mainlp2
		halt
		xor a
		out (254),a
		push bc
		call text_printer
		call stars_anim
		pop bc
		dec bc
		ld a,b
		or c
		jp nz,stars_mainlp2

		ret
		
text_clear
text_clear_pos
		ld hl,0x4005
		ld b,22
		push hl
text_clear_lp
		ld (hl),0
		inc hl
		djnz text_clear_lp
		pop hl
		call uphl
		ld (text_clear_pos+1),hl
		ret
		
uphl
	inc h
	ld a,h
	and 7
	ret nz
	ld a,l
	add a,32
	ld l,a
	ret c
	ld a,h
	sub 8
	ld h,a
	ret

text_printer
tp_frame
		ld a,39
		dec a
		ld (tp_frame+1),a
		ret nz
		ld a,39
		ld (tp_frame+1),a
tp_instr_ptr
		ld hl,tp_instructions
		ld e,(hl)	; where to copy to
		inc hl
		ld d,(hl)
		inc hl
		ld a,d
		or a
		ret z		; quit if zero
		; flash white
		ld a,0x1c
		ld bc,0x7ffd
		out (c),a
		ld a,7
		out (254),a
		
		; start fetching letters
tp_letter
		ld a,(hl)
		inc hl
		or a
		jp z,tp_end
		push hl
		;translate a into a font position
		ld h,0
		ld l,a
		add hl,hl
		add hl,hl
		add hl,hl
		add hl,hl
		add hl,hl
		ld bc,big_font - ('A'*32)
		add hl,bc
		push de
		rept 7
			ldi
			ldi
			dec e
			dec e
			inc d
		endm
		ldi
		ldi
		pop de
		push de
		set 5,e		; add 0x20
		rept 7
			ldi
			ldi
			dec e
			dec e
			inc d
		endm
		ldi
		ldi
		pop de
		inc e
		inc e
		pop hl
		jp tp_letter
tp_end
		ld (tp_instr_ptr+1),hl
		ret

tp_instructions
		dw 0x4005
		db "AS",0
		dw 0x400b
		db "A",0
		dw 0x400f
		db "PUBLIC",0
		dw 0x4049
		db "SERVICE",0
		dw 0x508a
		db "TO",0
		dw 0x5090
		db "THE",0
		dw 0x50c7
		db "DEMOSCENE",0
		dw 0x0000
tp_instructions2
		dw 0x4006
		db "WE",0
		dw 0x400c
		db "PRESENT",0
		dw 0x4046
		db "A",0
		dw 0x404a
		db "GUIDE",0
		dw 0x4056
		db "TO",0
		dw 0x5082
		db "RASTER", 0
		dw 0x5090
		db "EFFECTS",0
		dw 0x50c1
		db "ON",0
		dw 0x50c7
		db "THE",0
		dw 0x50cf
		db "SPECTRUM",0
		dw 0x0000
		
stars_anim
delta_pos
		ld hl,delta_dat
delta_frame_count
		ld a,star_frames
		push af
		call delta_frame
		pop af
		dec a
		jr z,delta_wrap
		ld (delta_frame_count+1),a
		ld (delta_pos+1),hl
		ret
delta_wrap
		ld hl,delta_dat
		ld (delta_pos+1),hl
		ld a,star_frames
		ld (delta_frame_count+1),a
		ret
				
delta_frame
		ld bc,0
deltalp
		ld a,(hl)
		inc hl
		rra
		rl c
		scf
		rra
		rl c
		rra
		rl c
		ret z
		ld d,a
		ld e,(hl)
		inc hl
		ldir
		jr deltalp
		
delta_dat
		incbin triad.dlt
		
big_font
		include "big_font.asm"