#!/usr/bin/ruby -w

# convert an xbm image to asm data with high bit on left, but rotated right two bits

xbm = File.new(ARGV[0])
bytes = [];
xbm.each { |line|
	next unless line =~ /^\s/
	line.scan(/0x../) { |bytecode|
		byte = Integer(bytecode)
		# switch bit ordering
		newbyte = 0
		(0..7).each do |i|
			if (byte & (1 << i) > 0)
				newbyte |= (1 << (7-i))
			end
		end

		# rotate right two bits - no, don't do that now
		# newbyte = ((newbyte & 0x3f) << 2) | ((newbyte & 0xc0) >> 6)

		bytes.push(newbyte);
	}
}

bytelines = []
0.step(bytes.length - 1, 16) { |i|
	bytelines.push(bytes.slice(i, 16));
}

for line in bytelines do
	puts "\tdb " + line.join(', ');
end